#!/usr/bin/env python
import yaml
import os
from xml.dom import minidom
import sys
sys.path.append('/scripts/')
import xmlapi


def writeconfded(user, domain, docroot, passedip, alias):
       user = user
       domain = domain
       passedip = passedip
       dedipvhost = """server {
       listen %s:80;
       server_name %s %s;
       root %s;
       access_log /usr/local/apache/domlogs/%s bytes_log;
       access_log /usr/local/apache/domlogs/%s combined;

       index index.php;

fastcgi_cache off;
#use host here to account for the fact that I have multiple WP instances
fastcgi_cache_key $scheme$host$request_uri;

fastcgi_cache_valid  200 302 304 30m;
fastcgi_cache_valid  301 1h;
fastcgi_cache_valid  any 5m;
fastcgi_cache_use_stale error timeout invalid_header updating http_500;
fastcgi_ignore_headers Expires Cache-Control;
fastcgi_pass_header Set-Cookie;

       location ~ \.(gif|jpeg|jpg|txt|png|css|js|htm|html|csv|doc|xls|xml|sql|ico)$ {
           access_log        off;
           expires           max;
       }

       location / {
               try_files       $uri $uri/ @bitrix;


       }

       location ~ \.php$ {
               try_files       $uri @bitrix;
               fastcgi_pass    unix:/var/run/php-fpm/php-fpm.sock;
               fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
               include fastcgi_params;
       }

       location @bitrix {
               fastcgi_pass    unix:/var/run/php-fpm/php-fpm.sock;
               include fastcgi_params;
               fastcgi_param SCRIPT_FILENAME $document_root/bitrix/urlrewrite.php;
       }

       location = /favicon.ico {
               log_not_found off;
               access_log off;
       }

       location = /robots.txt {
               allow all;
               log_not_found off;
               access_log off;
       }

       location ~ /\.ht {
           deny  all;
       }
       }""" % (passedip, domain, alias, docroot, domain, domain + "-bytes_log")
       if not os.path.exists( '/etc/nginx/vhosts'):
               os.makedirs('/etc/nginx/vhosts')
       if os.path.exists( '/etc/nginx/staticvhosts/' + domain):
               pass
       else:
               domainvhost = open ('/etc/nginx/vhosts/' + domain, 'w')
               domainvhost.writelines( dedipvhost )
               domainvhost.close()

def writeconfshared(user,domain,docroot,passedip, alias):
       sharedipvhost = """server {
       listen %s:80;
       server_name %s %s;
       root %s;
       access_log /usr/local/apache/domlogs/%s bytes_log;
       access_log /usr/local/apache/domlogs/%s combined;

       index index.php;

fastcgi_cache off;
#use host here to account for the fact that I have multiple WP instances
fastcgi_cache_key $scheme$host$request_uri;

fastcgi_cache_valid  200 302 304 30m;
fastcgi_cache_valid  301 1h;
fastcgi_cache_valid  any 5m;
fastcgi_cache_use_stale error timeout invalid_header updating http_500;
fastcgi_ignore_headers Expires Cache-Control;
fastcgi_pass_header Set-Cookie;

       location ~ \.(gif|jpeg|jpg|txt|png|css|js|htm|html|csv|doc|xls|xml|sql|ico)$ {
           access_log        off;
           expires           max;
       }

       location / {
               try_files       $uri $uri/ @bitrix;


       }

       location ~ \.php$ {
               try_files       $uri @bitrix;
               fastcgi_pass    unix:/var/run/php-fpm/php-fpm.sock;
               fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
               include fastcgi_params;
       }

       location @bitrix {
               fastcgi_pass    unix:/var/run/php-fpm/php-fpm.sock;
               include fastcgi_params;
               fastcgi_param SCRIPT_FILENAME $document_root/bitrix/urlrewrite.php;
       }

       location = /favicon.ico {
               log_not_found off;
               access_log off;
       }

       location = /robots.txt {
               allow all;
               log_not_found off;
               access_log off;
       }

       location ~ /\.ht {
           deny  all;
       }
       }""" % (passedip, domain, alias, docroot, domain, domain + "-bytes_log")

       if not os.path.exists( '/etc/nginx/vhosts'):
               os.makedirs('/etc/nginx/vhosts')
       if os.path.exists( '/etc/nginx/staticvhosts/' + domain):
               pass
       else:
               domainvhost = open ('/etc/nginx/vhosts/' + domain, 'w')
               domainvhost.writelines( sharedipvhost )
               domainvhost.close()

#def redirectfunc():



def getmainip():
       ipDOC = xmlapi.api("listips")
       parsedipDOC = minidom.parseString(ipDOC)
       iptaglist = parsedipDOC.getElementsByTagName('ip')
       serverip = iptaglist[0].childNodes[0].toxml()
       return serverip

def getipliststring():
       ipDOC = xmlapi.api("listips")
       parsedipDOC = minidom.parseString(ipDOC)
       iptaglist = parsedipDOC.getElementsByTagName('ip')
       iplist =[]

       q = 0
       while q < len(iptaglist):
               iplist.append(str(iptaglist[q].childNodes[0].toxml()))
               q = q + 1
       ipliststring = ' '.join(iplist)

       return ipliststring



def getvars(ydomain):
       DOC = xmlapi.api("domainuserdata?domain=" + ydomain)
       parsedDOC = minidom.parseString(DOC)
       docroottaglist = parsedDOC.getElementsByTagName('documentroot')
       yiptaglist = parsedDOC.getElementsByTagName('ip')
       aliastaglist=[]
       aliastaglist = parsedDOC.getElementsByTagName('serveralias')
       aliaslist =[]
       a = 0
       while a < len(aliastaglist):
               aliaslist.append(str(aliastaglist[a].childNodes[0].toxml()))
               a = a + 1
       alias = ''.join(aliaslist)
       docroot=""
       yip=""
       try:
               docroot = docroottaglist[0].childNodes[0].toxml()
               yip = yiptaglist[0].childNodes[0].toxml()

       except IndexError:
               errf=open('/root/failedcreation.txt', 'a')
               import time
               from time import strftime
               t=strftime("%Y-%m-%d %H:%M:%S")
               errortxt="%s Failed to create vhost for %s\n" % (t, ydomain)
               errf.write(errortxt)
               errf.close()

       return docroot, yip, alias

if __name__ == '__main__':
       DOC = xmlapi.api("listaccts")
       parsedDOC = minidom.parseString(DOC)
       usertaglist = parsedDOC.getElementsByTagName('user')
       userlist = []
       numusers = 0
       while numusers < len(usertaglist):
               userlist.append(str(usertaglist[numusers].childNodes[0].toxml()))
               numusers = numusers + 1
       for i in userlist:
               f = open('/var/cpanel/userdata/' + i + '/main')
               ydata = yaml.load(f)
               f.close()
               sublist = ydata['sub_domains']
               addondict = ydata['addon_domains']
               parkedlist = ydata['parked_domains']
               mainlist = ydata['main_domain']
               serverip = getmainip()
               if len(sublist) != 0:
                       slcont = 0
                       while slcont < len(sublist):
                               domain = sublist[slcont]
                               docroot, yip, alias = getvars(sublist[slcont])
                               if docroot == "":
                                       slcont = slcont + 1
                               else:
                                       if yip == serverip:
                                               writeconfshared(i, domain, docroot, yip, alias)
                                       else:
                                               writeconfded(i, domain, docroot, yip, alias)
                                       slcont = slcont + 1


               DOC = xmlapi.api("accountsummary?user=" + i)
               parsedDOC = minidom.parseString(DOC)
               domaintaglist = parsedDOC.getElementsByTagName('domain')
               domain = domaintaglist[0].childNodes[0].toxml()
               docroot, yip, alias = getvars(domain)
               if yip == serverip:
                      writeconfshared(i, domain, docroot, yip, alias)
               else:
                      writeconfded(i, domain, docroot, yip, alias)
